image: node:10

stages:
  - build
  - test
  - prod

cache:
   key: ${CI_COMMIT_REF_SLUG} 
   paths:
     - node_modules/ 

variables:
  STAGING_DOMAIN: http://localhost:9000
  GREP_FILE: ./public/index.html

build-website: 
    stage: build
    script:
      - echo $CI_COMMIT_SHORT_SHA
      - echo $ACCOUNT
      - npm install
      - npm install -g gatsby-cli
      - gatsby build 
    artifacts:
      paths:
        - ./public

test-artifact: 
    stage: test
    script:
      - grep -q "Gatsby" $GREP_FILE


test-website:
    stage: test
    when: manual
    allow_failure: false
    script:
      - npm install
      - npm install -g gatsby-cli
      - gatsby serve &    
      - sleep 10 
      - curl "$STAGING_DOMAIN" | tac | tac | grep -q "Gatsby" 

deploy-prod:
    stage: prod
    only:
       - master 
    when: manual
    script:
     - grep -q "Gatsby" $GREP_FILE      

#deploy-to-surge:
#  script:
##    - npm install --global surge
#    - surge --project ./public --domain lahormigadivina.surge.sh




      